/*
	SubSpace pseudo-random number generators by Catid@pacbell.net
*/

#ifndef PING_H
#define PING_H

#include "datatypes.h"
#include "sockets.h"

#define SWEEP_TIME 50

struct pingTarget	// Target of a ping sweep
{
	UDPSocket * s;				// Sockets access
	INADDR remote;				// Host address

	bool pinging;				// This target is being pinged
	Uint32 startTime;			// Time at which we started pinging

	Uint32 highPing;			// Host's longest response time

	Uint32 getTime();

	void sendPing();

	Uint32 population;			// Host population
	Uint32 lastPing;			// Host's latest response time
	Uint32 lastTime;			// Time at which we last pinged

	pingTarget(UDPSocket * ns, Uint32 ip, Uint16 port);

	void startPing();

	bool doEvents();

	bool validateSource(INADDR * src);

	void gotPong(Uint32 time, Uint32 pop);
};

class pingPort		// Receives & sends subspace pings
{
	UDPSocket s;

	_linkedlist <pingTarget> targets;

	_listnode <pingTarget> * myTarget;

	Uint32 population;

	Uint32 lastPing;

	void sendPong(INADDR * src, Uint32 ping);

	Uint32 getTime();

	pingTarget * findTarget(INADDR * src);

public:
	pingPort(Uint16 port);

	void setPopulation(Uint32 pop);

	void ping(Uint32 ip, Uint16 port);

	void doEvents();
};

#endif	// PING_H
